BOOT(8) | System Manager's Manual | BOOT(8)

# NAME

`boot` —
system bootstrapping procedures

# DESCRIPTION

This document provides information on using common features in the NetBSD boot loader. Additional information may be found in architecture-specific boot(8) manual pages.

## Boot Protocol

In the native NetBSD boot protocol, options are passed from the boot loader to the kernel via flag bits in the boothowto variable (see boothowto(9)). Some boot loaders may also support other boot protocols.

## Menu

Some boot loaders may present a menu, which may be configured via boot.cfg(5).

## Interactive mode

In interactive mode, the boot loader will present a prompt, allowing input of these commands:

`boot` [device:][filename] [`-1234abcdmqsvxz`]
  The default device will be set to the disk that the boot loader was loaded from. To boot from an alternate disk, the full name of the device should be given at the prompt. device is of the form xd [N[x]] where xd is the device from which to boot, N is the unit number, and x is the partition letter.

  The following list of supported devices may vary from installation to installation:

  hd
    Hard disks.
  fd
    Floppy drives.

  The default filename is netbsd; if the boot loader fails to successfully open that image, it then tries netbsd.gz (expected to be a kernel image compressed by gzip), followed by netbsd.old, netbsd.old.gz, onetbsd, and finally onetbsd.gz. Alternate system images can be loaded by just specifying the name of the image.

  Options are:

  `-1`
    Sets the machine-dependent flag RB_MD1 in boothowto.
  `-2`
    Sets the machine-dependent flag RB_MD2 in boothowto.
  `-3`
    Sets the machine-dependent flag RB_MD3 in boothowto.
  `-4`
    Sets the machine-dependent flag RB_MD4 in boothowto.
  `-a`
    Sets the RB_ASKNAME flag in boothowto. This causes the kernel to prompt for the root file system device, the system crash dump device, and the path to init(8).
  `-b`
    Sets the RB_HALT flag in boothowto. This causes subsequent reboot attempts to halt instead of rebooting.
  `-c`
    Sets the RB_USERCONF flag in boothowto. This causes the kernel to enter the userconf(4) device configuration manager as soon as possible during the boot. userconf(4) allows devices to be enabled or disabled, and allows device locators (such as hardware addresses or bus numbers) to be modified before the kernel attempts to attach the devices.
  `-d`
    Sets the RB_KDB flag in boothowto. Requests the kernel to enter debug mode, in which it waits for a connection from a kernel debugger; see ddb(4).
  `-m`
    Sets the RB_MINIROOT flag in boothowto. Informs the kernel that a mini-root file system is present in memory.
  `-q`
    Sets the AB_QUIET flag in boothowto. Boot the system in quiet mode.
  `-s`
    Sets the RB_SINGLE flag in boothowto. Boot the system in single-user mode.
  `-v`
    Sets the AB_VERBOSE flag in boothowto. Boot the system in verbose mode.
  `-x`
    Sets the AB_DEBUG flag in boothowto. Boot the system with debug messages enabled.
  `-z`
    Sets the AB_SILENT flag in boothowto. Boot the system in silent mode.
`consdev` dev
  Immediately switch the console to the specified device dev and reprint the banner. dev must be one of pc, com0, com1, com2, com3, com0kbd, com1kbd, com2kbd, com3kbd, or auto. See Console Selection Policy in x86/boot_console(8).
`dev` [device]
  Set the default drive and partition for subsequent filesystem operations. Without an argument, print the current setting. device is of the form specified in `boot`.
`help`
  Print an overview about commands and arguments.
`ls` [path]
  Print a directory listing of path, containing inode number, filename, and file type. path can contain a device specification.
`quit`
  Reboot the system.

In an emergency, the bootstrap methods described in the NetBSD installation notes for the specific architecture can be used.

# FILES

/boot
  boot program code loaded by the primary bootstrap
/netbsd
  system code
/netbsd.gz
  gzip-compressed system code
/usr/mdec/boot
  master copy of the boot program (copy to /boot)
/usr/mdec/bootxx_fstype
  primary bootstrap for filesystem type fstype, copied to the start of the NetBSD partition by installboot(8).

# SEE ALSO

Architecture-specific boot(8) manual pages (such as emips/boot(8), sparc64/boot(8), x86/boot(8)), ddb(4), userconf(4), halt(8), installboot(8), reboot(8), rescue(8), shutdown(8), boothowto(9)

# BUGS

The kernel file name must be specified before, not after, the boot options. Any filename specified after the boot options, e.g.:

    boot -d netbsd.test

is ignored, and the default kernel is booted.

August 16, 2014 | NetBSD 9.0